ST_CONNEXION
	BRA 	INIT
	BRA	END
	BRA	PLAY
; Adresse de la musique
	DC.L	0
	DC.W	0

INIT
	MOVEM.L D0-A6,-(SP)
	LEA	ST_CONNEXION(PC),A0
	MOVE.L	12(A0),A0
	LEA	OFFSET(PC),A1
	MOVE.W	#$1D8,POS(A1)
	MOVE.W	#$258,PATT(A1)
	MOVE.W	#$F,NBR(A1)
; Module du type 31 instruments ?
	CMP.L	#'M.K.',$438(A0)
	BNE.S	NO_NEW_MODULES
	MOVE.W	#$3B8,POS(A1)
	MOVE.W	#$43C,PATT(A1)
	MOVE.W	#$1F,NBR(A1)

NO_NEW_MODULES
	LEA	ST_CONNEXION(PC),A0
	MOVE.L	12(A0),A0
	LEA	OFFSET(PC),A1
	ADD.W	POS(A1),A0
	MOVEQ	#$7F,D0
	MOVEQ	#0,D1
; Nombre de patterns
.LOOP1
	MOVE.L	D1,D2
	SUBQ.W	#1,D0
.LOOP2
	MOVE.B	(A0)+,D1
	CMP.B	D2,D1
	BGT.S	.LOOP1
	DBF	D0,.LOOP2
	ADDQ.B	#1,D2
	SWAP	D2
	LSR.L	#6,D2
	LEA	ST_CONNEXION(PC),A0
	MOVE.L	12(A0),A0
	ADD.L	A0,D2
	LEA	$14(A0),A0
	LEA	OFFSET(PC),A1
	MOVE.W	NBR(A1),D7
	ADD.W	PATT(A1),D2
	MOVE.L	D2,A2
	LEA	SAMPLESTARTS(PC),A1
	LEA	(A1),A3
	MOVEQ	#$1E,D6

.LOOP3
	CLR.L	(A3)+
	DBRA	D6,.LOOP3
	SUBQ.W	#1,D7

.LOOP4
	CLR.L	(A2)
; Adresse de debut des samples
	MOVE.L	A2,(A1)+
	MOVEQ	#0,D1
	MOVE.W	22(A0),D1
	LSL.L	#1,D1
	MOVE.L	A2,A5
	ADD.L	D1,A2
	MOVE.L	A2,(A1)
	LEA	(A2),A6
	MOVE.W	22(A0),D6
	BEQ.S	.NO_REVERSE
	SUBQ.W	#1,D6

; Inverse les samples en memoire
.LOOP5
	MOVE.B	(A5),D2
	MOVE.B	-1(A6),D3
; Met les samples au format non signe
	EOR.B	#$80,D2
	EOR.B	#$80,D3
	MOVE.B	D3,(A5)+
	MOVE.B	D2,-(A6)
	DBRA	D6,.LOOP5

.NO_REVERSE
	CMP.W	#$0001,28(A0)
	BNE.S	.LOOP6
	CLR.W	28(A0)
.LOOP6
	LEA	$1E(A0),A0
	DBRA	D7,.LOOP4
	LEA	CHIP(PC),A0
	LEA	NO_INS(PC),A1
	MOVEQ	#$7,D0

.LOOP7
	MOVE.L	A1,(A0)+
	CLR.L	(A0)+
	CLR.L	(A0)+
	DBRA	D0,.LOOP7
	LEA	VOICES(PC),A0
	MOVEQ	#$1C-1,D0

.LOOP11
	CLR.L	(A0)+
	DBRA	D0,.LOOP11
; Initialise quelques datas
	LEA	OFFSET(PC),A0
	MOVE.B	#$6,SPEED(A0)
	CLR.B	SONGPOS(A0)
	CLR.B	COUNTER(A0)
	CLR.W	PATTPOS(A0)
	LEA	DIGIT_SWAP(PC),A0
	LEA	(DIGIT+1000)(PC),A1
	MOVE.L	A1,(A0)
	LEA	DIGIT(PC),A1
	MOVE.L	A1,4(A0)
	MOVE.W	#1000-1,D0

.LOOP8
	MOVE.W	#$400,(A1)+
	DBRA	D0,.LOOP8
	LEA	YET(PC),A0
	CMP.L	#'CNX',(A0)
	BEQ.S	.NO_CHANGE
	LEA	SOUND(PC),A0
	MOVE.W	#255,D0

.LOOP9
	MOVE.B	5(A0),6(A0)
	MOVE.B	5(A0),7(A0)
	MOVE.B	4(A0),5(A0)
	LEA	8(A0),A0
	DBRA	D0,.LOOP9
	LEA	VOLUME(PC),A0
	MOVE.W	#$3FFF,D0

.LOOP10
	MOVE.B	(A0),D1
; Transformation de la table de
; volume en donnes 6 bits
	LSR.B	#2,D1
	MOVE.B	D1,(A0)+
	DBRA	D0,.LOOP10
	LEA	YET(PC),A0
	MOVE.L	#'CNX',(A0)

.NO_CHANGE
; Yamaha Reset
	MOVE.L	#$00000000,$FFFF8800.W
	MOVE.L	#$01010000,$FFFF8800.W
	MOVE.L	#$02020000,$FFFF8800.W
	MOVE.L	#$03030000,$FFFF8800.W
	MOVE.L	#$04040000,$FFFF8800.W
	MOVE.L	#$05050000,$FFFF8800.W
	MOVE.L	#$06060000,$FFFF8800.W
	MOVE.L	#$0707FFFF,$FFFF8800.W
	MOVE.L	#$08080000,$FFFF8800.W
	MOVE.L	#$09090000,$FFFF8800.W
	MOVE.L	#$0A0A0000,$FFFF8800.W
; Sauve les interruptions
	LEA	STORE_INTERRUPTS(PC),A0
; VBL
	MOVE.L	$70.W,$0(A0)
; Timer A
	MOVE.L	$134.W,$4(A0)
	LEA	$FFFFFA00.W,A1
; IERA et IERB
	MOVEP.W	$7(A1),D0
	MOVE.W	D0,$8(A0)
; IMRA IMRB VR et TACR
	MOVEP.L	$13(A1),D0
	MOVE.L	D0,$A(A0)
	CLR.B	$19(A1)
; TADR
	MOVE.B	$1F(A1),$E(A0)
; Mouse off
	MOVE.B	#$12,$FFFFFC02.W
; Coupe le MFP
	CLR.B	$FFFFFA07.W
	CLR.B	$FFFFFA09.W
; Passage en fin automatique
; des interruptions
	BCLR.B	#$3,$FFFFFA17.W
	CLR.B	$FFFFFA19.W
; Positionne le TADR (registre
; de data du Timer A)
	MOVE.B	#FRQ_DATA,$FFFFFA1F.W
; Le prediviseur divise par 4
	MOVE.B	#1,$FFFFFA19.W
; Le Timer A est autorise
	OR.B	#32,$FFFFFA07.W
	OR.B	#32,$FFFFFA13.W
; Mise en place du Timer A
	LEA	SOUNDCHIP(PC),A0
	MOVE.L	A0,$134.W
	LEA	ST_CONNEXION(PC),A1
	LEA	16(A1),A1
	CMP.W	#1,(A1)
	BNE.S	MV16?
	LEA	ST_REPLAY(PC),A0
	MOVE.L	A0,$134.W
MV16?
	CMP.W	#2,(A1)
	BNE.S	SOUNDCHIP?
	LEA	MV16(PC),A0
	MOVE.L	A0,$134.W
SOUNDCHIP?
	MOVEM.L	(SP)+,D0-A6
	RTS

; Zone de sauvegarde du
; contexte du ST
STORE_INTERRUPTS
	REPT	8
	DC.W	0
	ENDR

END
	MOVEM.L	D0-A6,-(SP)
	LEA	STORE_INTERRUPTS(PC),A0
	MOVE.L	$0(A0),$70.W
	MOVE.L 	$4(A0),$134.W
	LEA	$FFFFFA00.W,A1
	MOVE.L	$A(A0),D0
	MOVEP.L	D0,$13(A1)
	CLR.B	$19(A1)
	MOVE.B	$E(A0),$1F(A1)
	MOVE.B	$D(A0),$19(A1)
	MOVE.W	$8(A0),D0
	MOVEP.W	D0,$7(A1)
; Mouse ON
	MOVE.B	#$8,$FFFFFC02.W
	MOVEM.L	(SP)+,D0-A6
	RTS

PLAY
	MOVE.W	#$2700,SR
	MOVEM.L	D0/A0,-(SP)
	LEA	DIGIT_SWAP(PC),A0
	MOVE.L	4(A0),D0
	MOVE.L	(A0),4(A0)
	MOVE.L	D0,(A0)
	LEA	GRRR(PC),A0
	MOVE.L	D0,2(A0)
	LEA	GRR(PC),A0
	MOVE.L	D0,2(A0)
	LEA	GR(PC),A0
	MOVE.L	D0,2(A0)
	MOVEM.L	(SP)+,D0/A0
	MOVE.W	#$2300,SR
	BSR	PLAYER
	BSR	PRECALC_DIGIT
	RTS

PLAYER
	MOVEM.L	D0-A6,-(SP)
	LEA	OFFSET(PC),A4
	ADDQ.B	#$1,COUNTER(A4)
	MOVE.B	COUNTER(A4),D0
	CMP.B	SPEED(A4),D0
	BLT.S	NONEW
	CLR.B	COUNTER(A4)
	BRA.S	READ_PATTERN

NONEW
	LEA	CHIP1(PC),A5
	LEA	VOICE1(PC),A6
	BSR	CHECK_COMMAND
	LEA	CHIP2(PC),A5
	LEA	VOICE2(PC),A6
	BSR	CHECK_COMMAND
	LEA	CHIP3(PC),A5
	LEA	VOICE3(PC),A6
	BSR	CHECK_COMMAND
	LEA	CHIP4(PC),A5
	LEA	VOICE4(PC),A6
	BSR	CHECK_COMMAND
	BRA	END_OF_PLAYER

READ_PATTERN
	LEA	ST_CONNEXION(PC),A0
	MOVE.L	12(A0),A0
	LEA	$C(A0),A3
	LEA	(A0),A2
	ADD.W	POS(A4),A2
	ADD.W	PATT(A4),A0
	MOVEQ	#0,D0
	MOVEQ	#0,D1
	MOVE.B	SONGPOS(A4),D0
	MOVE.B	0(A2,D0.W),D1
	SWAP	D1
	LSR.L	#$6,D1
	ADD.W	PATTPOS(A4),D1
	
	LEA	CHIP1(PC),A5
	LEA	VOICE1(PC),A6
	BSR.S	PLAYVOICE
	LEA	CHIP2(PC),A5
	LEA	VOICE2(PC),A6
	BSR.S	PLAYVOICE
	LEA	CHIP3(PC),A5
	LEA	VOICE3(PC),A6
	BSR.S	PLAYVOICE
	LEA	CHIP4(PC),A5
	LEA	VOICE4(PC),A6
	BSR.S	PLAYVOICE
	BRA	SET_REPEAT

; Routine qui traite une voie
PLAYVOICE
	MOVE.L	(A0,D1.L),(A6)
	ADDQ.L	#4,D1
	MOVEQ	#0,D2
	MOVE.B	$2(A6),D2
	AND.B	#$F0,D2
	LSR.B	#4,D2
	MOVE.B	(A6),D0
	AND.B	#$F0,D0
	OR.B	D0,D2
	TST.B	D2
	BEQ.S	SET_REGS
	MOVEQ	#0,D3
	LEA	SAMPLESTARTS(PC),A1
	MOVE.L	D2,D4
	SUBQ.L	#$1,D2
	ADD.W	D2,D2
	ADD.W	D2,D2
	MULU	#$1E,D4
	MOVE.L	(A1,D2.L),$4(A6)
	MOVE.W	(A3,D4.L),$8(A6)
	MOVE.W	$2(A3,D4.L),$12(A6)
	MOVE.W	$4(A3,D4.L),D3
	BRA.S	NO_LOOP
	MOVE.L	$4(A1,D2.L),$4(A6)
	ADD.W	$6(A3,D4.L),D3
	MOVE.W	D3,$8(A6)
	ADD.W	D3,D3
	SUB.L	D3,$4(A6)
	MOVE.L	$4(A6),$A(A6)
	MOVEQ	#0,D3
	MOVE.W	$6(A3,D4.L),D3
	MOVE.W	D3,$E(A6)
	MOVE.W	$12(A6),$8(A5)
	BRA.S	SET_REGS

NO_LOOP
	MOVE.L	$4(A6),$A(A6)
	MOVE.W	$6(A3,D4.L),$E(A6)
	MOVE.W	$12(A6),$8(A5)
SET_REGS
	MOVE.W	(A6),D0
	AND.W	#$FFF,D0
	BEQ	CHECK_COMMAND_2
	MOVE.B	$2(A6),D0
	AND.B	#$F,D0
	CMP.B	#$3,D0
	BNE.S	SETPERIOD
	BSR	SET_PORTAMENTO_TONE
	BRA	CHECK_COMMAND_2
SETPERIOD
	MOVE.W	(A6),$10(A6)
	AND.W	#$FFF,$10(A6)
	CLR.B	$1B(A6)
	MOVE.L	$4(A6),(A5)
	MOVEQ	#0,D0
	MOVE.W	$8(A6),D0
	ADD.W	D0,D0
	MOVE.L	D0,$4(A5)
	MOVE.W	$10(A6),$A(A5)
	BRA	CHECK_COMMAND_2

; Active les repeat des 4 voies
SET_REPEAT
	MOVEQ	#0,D0
	LEA	CHIP1(PC),A5
	LEA	VOICE1(PC),A6
	MOVE.L	$A(A6),$C(A5)
	MOVE.W	$E(A6),D0
	ADD.W	D0,D0
	MOVE.L	D0,$10(A5)
	LEA	CHIP2(PC),A5
	LEA	VOICE2(PC),A6
	MOVE.L	$A(A6),$C(A5)
	MOVE.W	$E(A6),D0
	ADD.W	D0,D0
	MOVE.L	D0,$10(A5)
	LEA	CHIP3(PC),A5
	LEA	VOICE3(PC),A6
	MOVE.L	$A(A6),$C(A5)
	MOVE.W	$E(A6),D0
	ADD.W	D0,D0
	MOVE.L	D0,$10(A5)
	LEA	CHIP4(PC),A5
	LEA	VOICE4(PC),A6
	MOVE.L	$A(A6),$C(A5)
	MOVE.W	$E(A6),D0
	ADD.W	D0,D0
	MOVE.L	D0,$10(A5)

	ADD.W	#$10,PATTPOS(A4)
	CMP.W	#$400,PATTPOS(A4)
	BNE.S	END_OF_PLAYER
NEXT_PATT
	CLR.W	PATTPOS(A4)
	CLR.B	BREAK(A4)
	ADDQ.B	#1,SONGPOS(A4)
	AND.B	#$7F,SONGPOS(A4)
	MOVE.B	SONGPOS(A4),d1
	LEA	ST_CONNEXION(PC),A0
	MOVE.L	12(A0),A0
	ADD.W	POS(A4),A0
	CMP.B	-2(A0),d1
	BNE.S	END_OF_PLAYER
	CLR.B	SONGPOS(A4)

END_OF_PLAYER
	TST.B	BREAK(A4)
	BNE.S	NEXT_PATT
	MOVEM.L	(SP)+,D0-A6
	RTS

CHECK_COMMAND
	MOVE.W	$2(A6),D0
	AND.W	#$FFF,D0
	BEQ.S	NO_COMMAND
	MOVE.B	$2(A6),D0
	AND.B	#$F,D0
	BEQ.S	ARPEGGIO
	CMP.B	#$1,D0
	BEQ	PORTAMENTO_UP
	CMP.B	#$2,D0
	BEQ	PORTAMENTO_DOWN
	CMP.B	#$3,D0
	BEQ	PORTAMENTO_TONE
	CMP.B	#$4,D0
	BEQ	VIBRATO
	MOVE.W	$10(A6),$A(A5)
	CMP.B	#$A,D0
	BEQ	VOLUME_SLIDE
NO_COMMAND
	RTS

ARPEGGIO
	MOVEQ	#0,D0
	MOVE.B	COUNTER(A4),D0
	DIVS	#$3,D0
	SWAP	D0
	CMP.W	#$0,D0
	BEQ.S	ARPEGGIO2
	CMP.S	#$2,D0
	BEQ.S	ARPEGGIO1
	MOVEQ	#0,D0
	MOVE.B	$3(A6),D0
	LSR.B	#$4,D0
	BRA.S	ARPEGGIO3
ARPEGGIO1
	MOVEQ	#0,D0
	MOVE.B	$3(A6),D0
	AND.B	#$F,D0
	BRA.S	ARPEGGIO3
ARPEGGIO2
	MOVE.W	$10(A6),D2
	BRA.S	ARPEGGIO4
ARPEGGIO3
	ADD.W	D0,D0
	MOVEQ	#0,D1
	MOVE.W	$10(A6),D1
	LEA	PERIODS(PC),A0
	MOVEQ	#$24,D7
ARPEGGIO_LOOP
	MOVE.W	(A0,D0.W),D2
	CMP.W	(A0),D1
	BGE.S	ARPEGGIO4
	LEA	2(A0),A0
	DBRA	D7,ARPEGGIO_LOOP
	RTS
ARPEGGIO4
	MOVE.W	D2,$A(A5)
	RTS

PORTAMENTO_UP
	MOVEQ	#0,D0
	MOVE.B	$3(A6),D0
	SUB.W	D0,$10(A6)
	MOVE.W	$10(A6),D0
	CMP.W	#$71,D0
	BPL.S	PORTUP
	MOVE.W	#$71,$10(A6)
PORTUP
	MOVE.W	$10(A6),$A(A5)
	RTS
PORTAMENTO_DOWN
	MOVEQ	#0,D0
	MOVE.B	$3(A6),D0
	ADD.W	D0,$10(A6)
	MOVE.W	$10(A6),D0
	CMP.W	#$358,D0
	BMI.S	PORTDWN
	MOVE.W	#$358,$10(A6)
PORTDWN
	MOVE.W	$10(A6),$A(A5)
	RTS

SET_PORTAMENTO_TONE
	MOVE.W	(A6),D2
	AND.W	#$FFF,D2
	MOVE.W	D2,$18(A6)
	MOVE.W	$10(A6),D0
	CLR.B	$16(A6)
	CMP.W	D0,D2
	BEQ.S	CLR_PORTAMENTO_TONE
	BGE.S	OK_RTS
	MOVE.B	#$1,$16(A6)
	RTS
CLR_PORTAMENTO_TONE
	CLR.W	$18(A6)
OK_RTS
	RTS

PORTAMENTO_TONE
	MOVE.B	$3(A6),D0
	BEQ.S	MY_SLIDE
	MOVE.B	D0,$17(A6)
	CLR.B	$3(A6)
MY_SLIDE
	TST.W	$18(A6)
	BEQ.S	OK_RTS
	MOVEQ	#0,D0
	MOVE.B	$17(A6),D0
	TST.B	$16(A6)
	BNE.S	MY_SUB
	ADD.W	D0,$10(A6)
	MOVE.W	$18(A6),D0
	CMP.W	$10(A6),D0
	BGT.S	MY_OK
	MOVE.W	$18(A6),$10(A6)
	CLR.W	$18(A6)
MY_OK
	MOVE.W	$10(A6),$A(A5)
	RTS
MY_SUB
	SUB.W	D0,$10(A6)
	MOVE.W	$18(A6),D0
	CMP.W	$10(A6),D0
	BLT.S	MY_OK
	MOVE.W	$18(A6),$10(A6)
	CLR.W	$18(A6)
	MOVE.W	$10(A6),$A(A5)
	RTS

VIBRATO
	MOVE.B	$3(A6),D0
	BEQ.S	VIB
	MOVE.B	D0,$1A(A6)
VIB
	MOVE.B	$1B(A6),D0
	LEA	SINUS(PC),A0
	LSR.W	#$2,D0
	AND.W	#$1F,D0
	MOVEQ	#0,D2
	MOVE.B	(A0,D0.W),D2
	MOVE.B	$1A(A6),D0
	AND.W	#$F,D0
	MULU	D0,D2
	LSR.W	#$6,D2
	MOVE.W	$10(A6),D0
	TST.B	$1B(A6)
	BMI.S	VIB_MIN
	ADD.W	D2,D0
	BRA.S	VIB2
VIB_MIN
	SUB.W	D2,D0
VIB2
	MOVE.W	D0,$A(A5)
	MOVE.B	$1A(A6),D0
	LSR.W	#$2,D0
	AND.W	#$3C,D0
	ADD.B	D0,$1B(A6)
	RTS

VOLUME_SLIDE
	MOVEQ	#0,D0
	MOVE.B	$3(A6),D0
	LSR.B	#4,D0
	TST.B	D0
	BEQ.S	VOLUME_DOWN
	ADD.W	D0,$12(A6)
	CMP.W	#$40,$12(A6)
	BMI.S	VOLUP_OK
	MOVE.W	#$40,$12(A6)
VOLUP_OK
	MOVE.W	$12(A6),$8(A5)
	RTS

VOLUME_DOWN
	MOVEQ	#0,D0
	MOVE.B	$3(A6),D0
	AND.B	#$F,D0
	SUB.W	D0,$12(A6)
	BPL.S	VOLDWN_OK
	CLR.W	$12(A6)
VOLDWN_OK
	MOVE.W	$12(A6),$8(A5)
	RTS

CHECK_COMMAND_2
	MOVE.B	$2(A6),D0
	AND.B	#$F,D0
	CMP.B	#$B,D0
	BEQ.S	POSITION_JUMP
	CMP.B	#$C,D0
	BEQ.S	SET_VOLUME
	CMP.B	#$D,D0
	BEQ.S	PATTERN_BREAK
	CMP.B	#$E,D0
	BEQ.S	SET_FILTER
	CMP.B	#$F,D0
	BEQ.S	SET_SPEED
	RTS

POSITION_JUMP
	MOVE.B	$3(A6),D0
	SUBQ.B	#$1,D0
	MOVE.B	D0,SONGPOS(A4)
	NOT.B	BREAK(A4)
	RTS
SET_VOLUME
	CMP.B	#$40,$3(A6)
	BLE.S	VOLUME_OK
	MOVE.B	#$40,$3(A6)
VOLUME_OK
	MOVE.B	$3(A6),$9(A5)
	RTS
PATTERN_BREAK
	NOT.B	BREAK(A4)
	RTS
SET_FILTER
	RTS
SET_SPEED
	MOVE.B	$3(A6),D0
	AND.W	#$1F,D0
	BEQ.S	NO_CHANGE_SPEED
	CLR.B	COUNTER(A4)
	MOVE.B	D0,SPEED(A4)
NO_CHANGE_SPEED
	RTS

PRECALC_DIGIT
	MOVEM.L	D0-A6,-(SP)
	LEA	VOLUME(PC),A3
	LEA	FRQ(PC),A4
	LEA	MEGABUFFER(PC),A5
	LEA	CHIP1(PC),A6
	BSR.S	CALC_VOICE
	LEA	MEGABUFFER+500(PC),A5
	LEA	CHIP2(PC),A6
	BSR.S	CALC_VOICE
	LEA	MEGABUFFER+1000(PC),A5
	LEA	CHIP3(PC),A6
	BSR.S	CALC_VOICE
	LEA	MEGABUFFER+1500(PC),A5
	LEA	CHIP4(PC),A6
	BSR.S	CALC_VOICE

	LEA	MEGABUFFER(PC),A0
	LEA	500(A0),A1
	LEA	500(A1),A2
	LEA	500(A2),A3
	LEA	DIGIT_SWAP(PC),A4
	MOVE.L	4(A4),A4
	BSR	MIX_ALL_VOICES
	MOVEM.L	(SP)+,D0-A6
	RTS

CALC_VOICE
	MOVE.L	$0(A6),A0
	MOVEQ	#0,D1
	MOVE.L	$4(A6),D3
	MOVE.W	$8(A6),D4
	BEQ.S	.VOLUME_NUL
	SUBQ.W	#1,D4

.VOLUME_NUL
	LSL.W	#$8,D4
	MOVE.L	$10(A6),D6
	MOVE.W	$A(A6),D7
	ADD.W	D7,D7
	ADD.W	D7,D7
	MOVE.L	(A4,D7.W),D7
	MOVE.W	D7,D0
	SWAP	D7
	MOVEQ	#0,D2
	MOVE.W	D7,D2
	SWAP	D7
	TST.L	D6
	BNE.S	.0
	CLR.L	D7

.0
	MOVE.L	$C(A6),A2
	MOVEQ	#FRQ_LOOP,D5
.PAULA
	SUB.W	D0,D1
	SUBX.W	D2,D3
	BCS.S	.R1
.RR1
	MOVE.B	0(A0,D3.L),D4
	MOVE.B	0(A3,D4.W),(A5)+
	SUB.W	D0,D1
	SUBX.W	D2,D3
	BCS.S	.R2
.RR2
	MOVE.B	0(A0,D3.L),D4
	MOVE.B	0(A3,D4.W),(A5)+
	SUB.W	D0,D1
	SUBX.W	D2,D3
	BCS.S	.R3
.RR3
	MOVE.B	0(A0,D3.L),D4
	MOVE.B	0(A3,D4.W),(A5)+
	DBRA	D5,.PAULA
	BRA.S	END_OF_CALC_A_VOICE
.R1
	MOVE.L	D6,D3
	MOVE.W	D7,D0
	SWAP	D7
	MOVE.W	D7,D2
	SWAP	D7
	MOVE.L	A2,A0
	BRA.S	.RR1
.R2
	MOVE.L	D6,D3
	MOVE.W	D7,D0
	SWAP	D7
	MOVE.W	D7,D2
	SWAP	D7
	MOVE.L	A2,A0
	BRA.S	.RR2
.R3
	MOVE.L	D6,D3
	MOVE.W	D7,D0
	SWAP	D7
	MOVE.W	D7,D2
	SWAP	D7
	MOVE.L	A2,A0
	BRA.S	.RR3
END_OF_CALC_A_VOICE
	MOVE.L	A0,$0(A6)
	MOVE.L	D3,$4(A6)
	RTS

MIX_ALL_VOICES
	MOVEQ	#FRQ_LOOP,D1
.LOOP
	MOVEQ	#0,D0
	MOVE.B	(A0)+,D0
	ADD.B	(A1)+,D0
	ADD.B	(A2)+,D0
	ADD.B	(A3)+,D0
	LSL.W	#3,D0
	MOVE.W	D0,(A4)+
	MOVEQ	#0,D0
	MOVE.B	(A0)+,D0
	ADD.B	(A1)+,D0
	ADD.B	(A2)+,D0
	ADD.B	(A3)+,D0
	LSL.W	#3,D0
	MOVE.W	D0,(A4)+
	MOVEQ	#0,D0
	MOVE.B	(A0)+,D0
	ADD.B	(A1)+,D0
	ADD.B	(A2)+,D0
	ADD.B	(A3)+,D0
	LSL.W	#3,D0
	MOVE.W	D0,(A4)+
	DBRA	D1,.LOOP
	MOVE.W	D0,(A4)+
	MOVE.W	D0,(A4)+
	MOVE.W	D0,(A4)+
	RTS
MV16
	MOVEM.L	D0/A0,-(SP)
GR
	LEA	DIGIT,A0
	MOVE.W	(A0),D0
	LEA	(GR+4)(PC),A0
	ADD.W	#2,(A0)
	LEA	$FFFA0000,A0
	ADD.W	D0,D0
	ADD.W	D0,D0
	MOVE.B	0(A0,D0.W),D0
	MOVE.L	(SP)+,D0
	MOVE.L	(SP)+,A0
	RTE

ST_REPLAY
	MOVEM.L	D0/A0,-(SP)
GRR
	LEA	DIGIT,A0
	MOVE.W	(A0),D0
	LEA	(GRR+4)(PC),A0
	ADD.W	#2,(A0)
	LEA	$FFFA0000,A0
	LSR.W	#2,D0
	MOVE.B	0(A0,D0.W),D0
	MOVE.L	(SP)+,D0
	MOVE.L	(SP)+,A0
	RTE

SOUNDCHIP
	MOVEM.L	D0/A0,-(SP)
GRRR
	LEA	DIGIT,A0
	MOVE.W	(A0),D0
	LEA	(GRRR+4)(PC),A0
	ADD.W	#2,(A0)
	LEA	SOUND(PC,D0.W),A0
	MOVE.L	(A0)+,D0
	MOVE.L	(A0),$FFFF8800.W
	LEA	$FFFF8800.W,A0
	MOVEP.L	D0,(A0)
	MOVE.L	(SP)+,D0
	MOVE.L	(SP)+,A0
	RTE

SOUND
	DC.W	$80E,$90D,$A0C,0,$80F,$903,$A00,0
	DC.W	$80F,$903,$A00,0,$80F,$903,$A00,0
	DC.W	$80F,$903,$A00,0,$80F,$903,$A00,0
	DC.W	$80F,$903,$A00,0,$80E,$90D,$A0B,0
	DC.W	$80E,$90D,$A0B,0,$80E,$90D,$A0B,0
	DC.W	$80E,$90D,$A0B,0,$80E,$90D,$A0B,0
	DC.W	$80E,$90D,$A0B,0,$80E,$90D,$A0B,0
	DC.W	$80E,$90D,$A0A,0,$80E,$90D,$A0A,0
	DC.W	$80E,$90D,$A0A,0,$80E,$90D,$A0A,0
	DC.W	$80E,$90C,$A0C,0,$80E,$90D,$A00,0
	DC.W	$80D,$90D,$A0D,0,$80D,$90D,$A0D,0
	DC.W	$80D,$90D,$A0D,0,$80D,$90D,$A0D,0
	DC.W	$80D,$90D,$A0D,0,$80D,$90D,$A0D,0
	DC.W	$80E,$90C,$A0B,0,$80E,$90C,$A0B,0
	DC.W	$80E,$90C,$A0B,0,$80E,$90C,$A0B,0
	DC.W	$80E,$90C,$A0B,0,$80E,$90C,$A0B,0
	DC.W	$80E,$90C,$A0B,0,$80E,$90C,$A0B,0
	DC.W	$80E,$90C,$A0A,0,$80E,$90C,$A0A,0
	DC.W	$80E,$90C,$A0A,0,$80E,$90C,$A0A,0
	DC.W	$80D,$90D,$A0C,0,$80D,$90D,$A0C,0
	DC.W	$80E,$90C,$A09,0,$80E,$90C,$A09,0
	DC.W	$80E,$90C,$A05,0,$80E,$90C,$A00,0
	DC.W	$80E,$90C,$A00,0,$80E,$90B,$A0B,0
	DC.W	$80E,$90B,$A0B,0,$80E,$90B,$A0B,0
	DC.W	$80E,$90B,$A0B,0,$80E,$90B,$A0A,0
	DC.W	$80E,$90B,$A0A,0,$80E,$90B,$A0A,0
	DC.W	$80D,$90D,$A0B,0,$80D,$90D,$A0B,0
	DC.W	$80D,$90D,$A0B,0,$80E,$90B,$A09,0
	DC.W	$80E,$90B,$A09,0,$80E,$90B,$A09,0
	DC.W	$80D,$90C,$A0C,0,$80D,$90D,$A0A,0
	DC.W	$80E,$90B,$A07,0,$80E,$90B,$A00,0
	DC.W	$80E,$90B,$A00,0,$80D,$90D,$A09,0
	DC.W	$80D,$90D,$A09,0,$80E,$90A,$A09,0
	DC.W	$80D,$90D,$A08,0,$80D,$90D,$A07,0
	DC.W	$80D,$90D,$A04,0,$80D,$90D,$A00,0
	DC.W	$80E,$90A,$A04,0,$80E,$909,$A09,0
	DC.W	$80E,$909,$A09,0,$80D,$90C,$A0B,0
	DC.W	$80E,$909,$A08,0,$80E,$909,$A08,0
	DC.W	$80E,$909,$A07,0,$80E,$908,$A08,0
	DC.W	$80E,$909,$A01,0,$80C,$90C,$A0C,0
	DC.W	$80D,$90C,$A0A,0,$80E,$908,$A06,0
	DC.W	$80E,$907,$A07,0,$80E,$908,$A00,0
	DC.W	$80E,$907,$A05,0,$80E,$906,$A06,0
	DC.W	$80D,$90C,$A09,0,$80E,$905,$A05,0
	DC.W	$80E,$904,$A04,0,$80D,$90C,$A08,0
	DC.W	$80D,$90B,$A0B,0,$80E,$900,$A00,0
	DC.W	$80D,$90C,$A06,0,$80D,$90C,$A05,0
	DC.W	$80D,$90C,$A02,0,$80C,$90C,$A0B,0
	DC.W	$80C,$90C,$A0B,0,$80D,$90B,$A0A,0
	DC.W	$80D,$90B,$A0A,0,$80D,$90B,$A0A,0
	DC.W	$80D,$90B,$A0A,0,$80C,$90C,$A0A,0
	DC.W	$80C,$90C,$A0A,0,$80C,$90C,$A0A,0
	DC.W	$80D,$90B,$A09,0,$80D,$90B,$A09,0
	DC.W	$80D,$90A,$A0A,0,$80D,$90A,$A0A,0
	DC.W	$80D,$90A,$A0A,0,$80C,$90C,$A09,0
	DC.W	$80C,$90C,$A09,0,$80C,$90C,$A09,0
	DC.W	$80D,$90B,$A06,0,$80C,$90B,$A0B,0
	DC.W	$80C,$90C,$A08,0,$80D,$90B,$A00,0
	DC.W	$80D,$90B,$A00,0,$80C,$90C,$A07,0
	DC.W	$80C,$90C,$A06,0,$80C,$90C,$A05,0
	DC.W	$80C,$90C,$A03,0,$80C,$90C,$A01,0
	DC.W	$80C,$90B,$A0A,0,$80D,$90A,$A05,0
	DC.W	$80D,$90A,$A04,0,$80D,$90A,$A02,0
	DC.W	$80D,$909,$A08,0,$80D,$909,$A08,0
	DC.W	$80C,$90B,$A09,0,$80C,$90B,$A09,0
	DC.W	$80D,$908,$A08,0,$80B,$90B,$A0B,0
	DC.W	$80D,$909,$A05,0,$80C,$90B,$A08,0
	DC.W	$80D,$909,$A02,0,$80D,$908,$A06,0
	DC.W	$80C,$90B,$A07,0,$80D,$907,$A07,0
	DC.W	$80C,$90B,$A06,0,$80C,$90A,$A09,0
	DC.W	$80B,$90B,$A0A,0,$80C,$90B,$A02,0
	DC.W	$80C,$90B,$A00,0,$80C,$90A,$A08,0
	DC.W	$80D,$906,$A04,0,$80D,$905,$A05,0
	DC.W	$80D,$905,$A04,0,$80C,$909,$A09,0
	DC.W	$80D,$904,$A03,0,$80B,$90B,$A09,0
	DC.W	$80C,$90A,$A05,0,$80B,$90A,$A0A,0
	DC.W	$80C,$909,$A08,0,$80B,$90B,$A08,0
	DC.W	$80C,$90A,$A00,0,$80C,$90A,$A00,0
	DC.W	$80C,$909,$A07,0,$80B,$90B,$A07,0
	DC.W	$80C,$909,$A06,0,$80B,$90B,$A06,0
	DC.W	$80B,$90A,$A09,0,$80B,$90B,$A05,0
	DC.W	$80A,$90A,$A0A,0,$80B,$90B,$A02,0
	DC.W	$80B,$90A,$A08,0,$80C,$907,$A07,0
	DC.W	$80C,$908,$A04,0,$80C,$907,$A06,0
	DC.W	$80B,$909,$A09,0,$80C,$906,$A06,0
	DC.W	$80A,$90A,$A09,0,$80C,$907,$A03,0
	DC.W	$80B,$90A,$A05,0,$80B,$909,$A08,0
	DC.W	$80B,$90A,$A03,0,$80A,$90A,$A08,0
	DC.W	$80B,$90A,$A00,0,$80B,$909,$A07,0
	DC.W	$80B,$908,$A08,0,$80A,$90A,$A07,0
	DC.W	$80A,$909,$A09,0,$80C,$901,$A01,0
	DC.W	$80A,$90A,$A06,0,$80B,$908,$A07,0
	DC.W	$80A,$90A,$A05,0,$80A,$909,$A08,0
	DC.W	$80A,$90A,$A02,0,$80A,$90A,$A01,0
	DC.W	$80A,$90A,$A00,0,$809,$909,$A09,0
	DC.W	$80A,$908,$A08,0,$80B,$908,$A01,0
	DC.W	$80A,$909,$A06,0,$80B,$907,$A04,0
	DC.W	$80A,$909,$A05,0,$809,$909,$A08,0
	DC.W	$80A,$909,$A03,0,$80A,$908,$A06,0
	DC.W	$80A,$909,$A00,0,$809,$909,$A07,0
	DC.W	$809,$908,$A08,0,$80A,$908,$A04,0
	DC.W	$809,$909,$A06,0,$80A,$908,$A01,0
	DC.W	$809,$909,$A05,0,$809,$908,$A07,0
	DC.W	$808,$908,$A08,0,$809,$909,$A02,0
	DC.W	$809,$908,$A06,0,$809,$909,$A00,0
	DC.W	$809,$907,$A07,0,$808,$908,$A07,0
	DC.W	$809,$907,$A06,0,$809,$908,$A02,0
	DC.W	$808,$908,$A06,0,$809,$906,$A06,0
	DC.W	$808,$907,$A07,0,$808,$908,$A04,0
	DC.W	$808,$907,$A06,0,$808,$908,$A02,0
	DC.W	$807,$907,$A07,0,$808,$906,$A06,0
	DC.W	$808,$907,$A04,0,$807,$907,$A06,0
	DC.W	$808,$906,$A05,0,$808,$906,$A04,0
	DC.W	$807,$906,$A06,0,$807,$907,$A04,0
	DC.W	$808,$905,$A04,0,$806,$906,$A06,0
	DC.W	$807,$906,$A04,0,$807,$905,$A05,0
	DC.W	$806,$906,$A05,0,$806,$906,$A04,0
	DC.W	$806,$905,$A05,0,$806,$906,$A02,0
	DC.W	$806,$905,$A04,0,$805,$905,$A05,0
	DC.W	$806,$905,$A02,0,$805,$905,$A04,0
	DC.W	$805,$904,$A04,0,$805,$905,$A02,0
	DC.W	$804,$904,$A04,0,$804,$904,$A03,0
	DC.W	$804,$904,$A02,0,$804,$903,$A03,0
	DC.W	$803,$903,$A03,0,$803,$903,$A02,0
	DC.W	$803,$902,$A02,0,$802,$902,$A02,0
	DC.W	$802,$902,$A01,0,$801,$901,$A01,0
	DC.W	$802,$901,$A00,0,$801,$901,$A00,0
	DC.W	$801,$900,$A00,0,$800,$900,$A00,0

SINUS
	DC.B	$00,$18,$31,$4A,$61,$78,$8D,$A1,$B4
	DC.B	$C5,$D4,$E0,$EB,$F4,$FA,$FD
	DC.B	$FF,$FD,$FA,$F4,$EB,$E0,$D4,$C5,$B4
	DC.B	$A1,$8D,$78,$61,$4A,$31,$18

PERIODS
	DC.W	$0358,$0328,$02FA,$02D0,$02A6,$0280
	DC.W	$025C,$023A,$021A,$01FC,$01E0
	DC.W	$01C5,$01AC,$0194,$017D,$0168,$0153
	DC.W	$0140,$012E,$011D,$010D,$00FE
	DC.W	$00F0,$00E2,$00D6,$00CA,$00BE,$00B4
	DC.W	$00AA,$00A0,$0097,$008F,$0087
	DC.W	$007F,$0078,$0071,$0000,$0000

OFFSET
	REPT 	$6
	DC.W	0
	ENDR
SPEED	EQU	$0
SONGPOS	EQU	$1
PATTPOS	EQU	$2
COUNTER	EQU	$4
BREAK	EQU	$5
POS	EQU	$6
PATT	EQU	$8
NBR	EQU	$A
SAMPLESTARTS
	REPT	$20
	DC.L	0
	ENDR
VOICES
	REPT	$1C
	DC.L	0
	ENDR
VOICE1	EQU	VOICES
VOICE2	EQU	VOICES+$1C
VOICE3	EQU	VOICES+$38
VOICE4	EQU	VOICES+$54
CHIP
	REPT	$18
	DC.L	0
	ENDR
CHIP1	EQU	CHIP
CHIP2	EQU	CHIP+$18
CHIP3	EQU	CHIP+$30
CHIP4	EQU	CHIP+$48
NO_INS	DC.W	$8080
MEGABUFFER
	REPT	500
	DC.L	0
	ENDR
DIGIT
	REPT	500*2
	DC.W	0
	ENDR
DIGIT_SWAP
	REPT	2
	DC.L	0
	ENDR
FRQ_LOOP	EQU	49
FRQ_DATA	EQU	44
FRQ	DC.L	0
	INCBIN	'E:\14_KHZ.FRQ'
YET	DC.L	0
VOLUME	INCBIN	'E:\VOLUME.BIN'
